/*
 * addon.cu
 *
 *  Created on: 7 mai 2013
 *      Author: technic105
 */

#include "addon.cu.h"

__device__ func pfunc1 = fcalc1;
__device__ func pfunc2 = fcalc2;
__device__ func pfunc3 = fcalc3;
__device__ func pfunc4 = fcalc4;


void get_func_address(func* h_f)
{
	checkCudaErrors(cudaMemcpyFromSymbol( h_f, pfunc1, sizeof(func)));
	checkCudaErrors(cudaMemcpyFromSymbol( h_f+1, pfunc2, sizeof(func)));
	checkCudaErrors(cudaMemcpyFromSymbol( h_f+2, pfunc3, sizeof(func)));
	checkCudaErrors(cudaMemcpyFromSymbol( h_f+3, pfunc4, sizeof(func)));
}




__device__ void fcalc1(funcParam* param)
{
	int pos=threadIdx.x+512*blockIdx.x;
	float x=param->fpDeviceBuffer[pos];
	funcParam1* mParam = ((funcParam1*)param);
	//param->fpDeviceBuffer[pos]=(mParam->param3+(x+mParam->param0/mParam->param1))*mParam->param2;
	param->fpDeviceBuffer[pos]=x+mParam->param3;

}
__device__ void fcalc2(funcParam* param)
{
	int pos=threadIdx.x+512*blockIdx.x;
	float x=param->fpDeviceBuffer[pos];
	funcParam2* mParam = ((funcParam2*)param);
	//param->fpDeviceBuffer[pos]=(mParam->param3+(x+mParam->param0/mParam->param1))*mParam->param2;
	param->fpDeviceBuffer[pos]=x+mParam->param3;
}


__device__ void fcalc3(funcParam* param)
{
	int pos=threadIdx.x+512*blockIdx.x;
	float x=param->fpDeviceBuffer[pos];
	funcParam3* mParam = ((funcParam3*)param);
	//param->fpDeviceBuffer[pos]=(mParam->param3+(x+mParam->param0/mParam->param1))*mParam->param2;
	param->fpDeviceBuffer[pos]=x+mParam->param3;
}
__device__ void fcalc4(funcParam* param)
{
	int pos=threadIdx.x+512*blockIdx.x;
	float x=param->fpDeviceBuffer[pos];
	funcParam4* mParam = ((funcParam4*)param);
	//param->fpDeviceBuffer[pos]=(mParam->param3+(x+mParam->param0/mParam->param1))*mParam->param2;
	param->fpDeviceBuffer[pos]=x+mParam->param3;
}

