/*
 * main.cu.h
 *
 *  Created on: 7 mai 2013
 *      Author: technic105
 */

#ifndef MAIN_CU_H_
#define MAIN_CU_H_

#include <stdio.h>
#include <stdlib.h>
#include <iostream>

//cuda
#include <helper_cuda.h>


#define NUMBER_FUNCTION 4

typedef struct funcParam
{
	funcParam(void)
	{
		param0=1;
	}
	int param0;
	float *fpDeviceBuffer;
}funcParam;

typedef struct funcParam1 : funcParam
{
	funcParam1(void)
		{
			param1=1;
			param2=1;
			param3=1;
		}
	int param1;
	float param2;
	int param3;
}funcParam1;

typedef struct funcParam2 : funcParam
{
	funcParam2(void)
	{
		param1=1;
		param2=1;
		param3=1;
	}
	int param1;
	int param2;
	double param3;
}funcParam2;

typedef struct funcParam3 : funcParam
{
	funcParam3(void)
	{
		param1=1;
		param2=1;
		param3=1;
	}
	int param1;
	float param2;
	float param3;
}funcParam3;

typedef struct funcParam4 : funcParam
{
	funcParam4(void)
	{
		param1=1;
		param2=1;
		param3=1;
	}
	int param1;
	double param2;
	float param3;
}funcParam4;

typedef void (*func)(funcParam*);

//Main kernel that will Launch functions serially
__global__ void calcbis(float* fpDeviceBuffer, func* f, funcParam** param, int n);

//"Classic" kernels
__global__ void calc1(funcParam1 param);
__global__ void calc2(funcParam2 param);
__global__ void calc3(funcParam3 param);
__global__ void calc4(funcParam4 param);





#endif /* MAIN_CU_H_ */
